## herbstluftwm 0.9.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1...3.13)

file(STRINGS VERSION VERSION) # read hlwm version from file 'VERSION'
project(Herbstluftwm
    VERSION ${VERSION})

# use our cmake dir for include(…) statements
list(INSERT CMAKE_MODULE_PATH 0 "${PROJECT_SOURCE_DIR}/cmake")

# make CMake behave our way
include(behavior)
# get project dependencies
include(dependencies)
# generate variable PROJECT_VERSION_GIT, provide function export_version()
include(gitversion)
# add custom (default) debug flags in variable cache
include(debugflags)
# find ccache (offered via ENABLE_CCACHE if available)
include(ccache)

## set install variables
# prefix for systemwide configuration, accompanies CMAKE_INSTALL_PREFIX
set(CMAKE_INSTALL_SYSCONF_PREFIX "/etc" CACHE PATH
    "Top-level install path for configuration files. May be given relative to CMAKE_INSTALL_PREFIX.")

set(CONFIGDIR "${CMAKE_INSTALL_SYSCONF_PREFIX}/xdg/herbstluftwm")
set(BINDIR bin)
set(DATADIR share)
set(MANDIR ${DATADIR}/man)
set(DOCDIR ${DATADIR}/doc/herbstluftwm)
set(LICENSEDIR ${DOCDIR}
    CACHE PATH "Install path for license file")
set(XSESSIONSDIR ${DATADIR}/xsessions
    CACHE PATH "Install path for xsession file")
set(ZSHCOMPLETIONDIR ${DATADIR}/zsh/site-functions
    CACHE PATH "Install path for zsh completions file")
set(FISHCOMPLETIONDIR ${DATADIR}/fish/vendor_completions.d
    CACHE PATH "Install path for fish completions file")
set(BASHCOMPLETIONDIR ${DATADIR}/bash-completion/completions
    CACHE PATH "Install path for bash completions file")

## do the actual work
add_subdirectory(ipc-client)
add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(share)

## install everything that was not installed from subdirectories
install(FILES NEWS DESTINATION ${DOCDIR})
install(FILES LICENSE DESTINATION ${LICENSEDIR})
install(DIRECTORY scripts/ DESTINATION ${DOCDIR}/examples USE_SOURCE_PERMISSIONS)

# vim: et:ts=4:sw=4

=== Makefile ===
## Wrapper around cmake

VERSION = $(shell cat VERSION)

.PHONY: all all-nodoc doc

BUILDDIR = build

all: $(BUILDDIR)
	cd $(BUILDDIR) && $(MAKE)
	@echo The compilation result can be found in $(BUILDDIR)/

$(BUILDDIR):
	mkdir -p $@
	cd $@ && cmake ..

clean:
	rm -r $(BUILDDIR)/

=== doc/CMakeLists.txt ===
option(WITH_DOCUMENTATION "Build with documentation" ON)

# don't rebuilt but instead only copy the documentation if hlwm-doc.json exists
# in the source directory
if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/hlwm-doc.json")
    set(doc_exists_in_src ON)
else()
    set(doc_exists_in_src OFF)
endif()
option(COPY_DOCUMENTATION "Use pre-built documentation (only available in tarballs)" ${doc_exists_in_src})

add_custom_target("all_doc")

function(gen_json_doc destfile)
    set(dst "${CMAKE_CURRENT_BINARY_DIR}/${destfile}.json")
    AUX_SOURCE_DIRECTORY("${CMAKE_CURRENT_SOURCE_DIR}/../src" CPPSRC)
    add_custom_target("doc_json" DEPENDS ${dst})
    if (COPY_DOCUMENTATION)
        set(dst_prebuilt "${CMAKE_CURRENT_SOURCE_DIR}/${destfile}.json")
        add_custom_command(
            OUTPUT ${dst}
            COMMAND ${CMAKE_COMMAND} -E copy ${dst_prebuilt} ${dst}
            DEPENDS ${dst_prebuilt}
            COMMENT "Using pre-built ${dst_prebuilt}"
            )
    else()
        add_custom_command(
            OUTPUT ${dst}
            COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/gendoc.py" --sourcedir "${CMAKE_CURRENT_SOURCE_DIR}/../src" --json > ${dst}
            DEPENDS ${CPPSRC} "${CMAKE_CURRENT_SOURCE_DIR}/gendoc.py"
            )
    endif()
    install(FILES ${dst} DESTINATION ${DOCDIR} OPTIONAL)
endfunction()

function(gen_object_asciidoc jsonfile destfile)
    set(dst "${CMAKE_CURRENT_BINARY_DIR}/${destfile}")
    set(absjson "${CMAKE_CURRENT_BINARY_DIR}/${jsonfile}")
    add_custom_target(gen_object_asciidoc DEPENDS ${dst} doc_json)
    if (COPY_DOCUMENTATION)
        set(dst_prebuilt "${CMAKE_CURRENT_SOURCE_DIR}/${destfile}")
        add_custom_command(
            OUTPUT ${dst}
            COMMAND ${CMAKE_COMMAND} -E copy ${dst_prebuilt} ${dst}
            DEPENDS ${dst_prebuilt}
            COMMENT "Using pre-built ${dst_prebuilt}"
            )
    else()
        add_custom_command(
            OUTPUT ${dst}
            COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/format-doc.py" ${absjson} > ${dst}
            DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/format-doc.py" ${absjson}
            )
    endif()
endfunction()

function(gen_manpage sourcefile man_nr)
    # additional arguments (${ARGN}) are passed as DEPENDS to the asciidoc command
    set(src "${CMAKE_CURRENT_SOURCE_DIR}/${sourcefile}.txt")
    set(dst "${CMAKE_CURRENT_BINARY_DIR}/${sourcefile}.${man_nr}")
    STRING(TIMESTAMP BUILD_DATE "%Y-%m-%d" UTC)

    # as a hack, every man page depends on gen_object_asciidoc, even though only
    # 'herbstluftwm' needs it. We do this to avoid that hlwm-doc.json is built
    # multiple times when make is invoked with -j8
    add_custom_target("doc_man_${sourcefile}" ALL DEPENDS ${dst} gen_object_asciidoc)
    add_dependencies(all_doc "doc_man_${sourcefile}")
    if (COPY_DOCUMENTATION)
        set(dst_prebuilt "${CMAKE_CURRENT_SOURCE_DIR}/${sourcefile}.${man_nr}")
        add_custom_command(
            OUTPUT ${dst}
            COMMAND ${CMAKE_COMMAND} -E copy ${dst_prebuilt} ${dst}
            DEPENDS ${dst_prebuilt}
            COMMENT "Using pre-built ${dst_prebuilt}"
            )
    else()
        add_custom_command(
            OUTPUT ${dst}
            COMMAND ${ASCIIDOC_A2X}
                    --no-xmllint
                    -f manpage
                    -a \"herbstluftwmversion=herbstluftwm ${VERSION}\"
                    -a \"date=${BUILD_DATE}\"
                    -a \"builddir=${CMAKE_CURRENT_BINARY_DIR}\"
                    --destination-dir="${CMAKE_CURRENT_BINARY_DIR}"
                    ${src}
            DEPENDS ${ARGN}
            )
    endif()
    install(FILES ${dst} DESTINATION "${MANDIR}/man${man_nr}")
endfunction()

function(gen_html sourcefile)
    # additional arguments (${ARGN}) are passed as DEPENDS to the asciidoc command
    set(src "${CMAKE_CURRENT_SOURCE_DIR}/${sourcefile}.txt")
    set(dst "${CMAKE_CURRENT_BINARY_DIR}/${sourcefile}.html")

    # as a hack, every html doc depends on gen_object_asciidoc, even though only
    # 'herbstluftwm' needs it. We do this to avoid that hlwm-doc.json is built
    # multiple times when make is invoked with -j8
    # 'herbstluftwm' needs it
    add_custom_target("doc_html_${sourcefile}" ALL DEPENDS ${dst} gen_object_asciidoc)
    add_dependencies(all_doc "doc_html_${sourcefile}")
    if (COPY_DOCUMENTATION)
        set(dst_prebuilt "${CMAKE_CURRENT_SOURCE_DIR}/${sourcefile}.html")
        add_custom_command(
            OUTPUT ${dst}
            COMMAND ${CMAKE_COMMAND} -E copy ${dst_prebuilt} ${dst}
            DEPENDS ${dst_prebuilt}
            COMMENT "Using pre-built ${dst_prebuilt}"
            )
    else()
        add_custom_command(
            OUTPUT ${dst}
            COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_CURRENT_BINARY_DIR}"
            COMMAND ${ASCIIDOC}
                        -o ${dst}
                        -a \"builddir=${CMAKE_CURRENT_BINARY_DIR}\"
                        ${src}
            DEPENDS ${src} ${ARGN}
            )
    endif()
    install(FILES ${dst} DESTINATION ${DOCDIR})
endfunction()


# always create a doc_json target, but only make it mandatory
# if WITH_DOCUMENTATION is set
gen_json_doc(hlwm-doc)

if (WITH_DOCUMENTATION)
    if (NOT COPY_DOCUMENTATION)
        find_program(ASCIIDOC_A2X NAMES a2x DOC "Path to AsciiDoc a2x command")
        find_program(ASCIIDOC NAMES asciidoc DOC "Path to AsciiDoc command")
    endif()

    gen_manpage(herbstclient 1)
    gen_manpage(herbstluftwm 1 "${CMAKE_CURRENT_BINARY_DIR}/hlwm-objects-gen.txt")
    gen_manpage(herbstluftwm-tutorial 7)

    gen_html(herbstclient)
    gen_html(herbstluftwm "${CMAKE_CURRENT_BINARY_DIR}/hlwm-objects-gen.txt")
    gen_html(herbstluftwm-tutorial)

    gen_object_asciidoc("hlwm-doc.json" "hlwm-objects-gen.txt")
endif()

# vim: et:ts=4:sw=4

=== ipc-client/CMakeLists.txt ===
## The 'herbstclient' executable ##

add_executable(herbstclient main.c)
install(TARGETS herbstclient DESTINATION ${BINDIR})

# additional sources
target_sources(herbstclient PRIVATE
    client-utils.c	client-utils.h
    ipc-client.c	ipc-client.h
    )

# we require C99, X/Open 6 for POSIX 2004
set_target_properties(herbstclient PROPERTIES
    C_STANDARD 99
    C_STANDARD_REQUIRED ON
    COMPILE_DEFINITIONS _XOPEN_SOURCE=600)

# dependencies X11
target_include_directories(herbstclient SYSTEM PUBLIC
    ${X11_INCLUDE_DIRS})
target_link_libraries(herbstclient PUBLIC
    ${X11_LIBRARIES})

# communicate version string
export_version(main.c)

# vim: et:ts=4:sw=4

=== src/CMakeLists.txt ===
## The 'herbstluftwm' executable ##

add_executable(herbstluftwm main.cpp)
install(TARGETS herbstluftwm DESTINATION ${BINDIR})

# additional sources – core/architectural stuff
target_sources(herbstluftwm PRIVATE
    arglist.cpp arglist.h
    argparse.cpp argparse.h
    attribute.cpp attribute.h attribute_.h
    byname.cpp byname.h
    child.h
    client.cpp client.h
    clientmanager.cpp clientmanager.h
    command.cpp command.h
    commandio.cpp commandio.h
    completion.h
    completion.h completion.cpp
    decoration.cpp decoration.h
    desktopwindow.h desktopwindow.cpp
    entity.cpp entity.h
    ewmh.cpp ewmh.h
    finite.h
    fixprecdec.cpp fixprecdec.h
    floating.cpp floating.h
    font.cpp font.h
    fontdata.cpp fontdata.h
    framedata.h framedata.cpp
    framedecoration.cpp framedecoration.h
    frameparser.h frameparser.cpp
    frametree.h frametree.cpp
    globals.h
    hlwmcommon.cpp hlwmcommon.h
    hook.cpp hook.h
    indexingobject.h
    ipc-protocol.h
    ipc-server.cpp ipc-server.h
    keycombo.cpp keycombo.h
    keymanager.cpp keymanager.h
    layout.cpp layout.h
    link.h
    metacommands.cpp metacommands.h
    monitor.cpp monitor.h
    monitordetection.cpp monitordetection.h
    monitormanager.cpp monitormanager.h
    mouse.cpp mouse.h
    mousemanager.cpp mousemanager.h
    mousedraghandler.cpp mousedraghandler.h
    namedhook.cpp namedhook.h
    object.cpp object.h
    optional.h
    plainstack.h
    panelmanager.h panelmanager.cpp
    rectangle.cpp rectangle.h
    regexstr.cpp regexstr.h
    root.cpp root.h
    rulemanager.cpp rulemanager.h
    rules.cpp rules.h
    settings.cpp settings.h
    signal.h
    stack.cpp stack.h
    tag.cpp tag.h
    tagmanager.cpp tagmanager.h
    theme.cpp theme.h
    tilingresult.cpp tilingresult.h
    tmp.cpp tmp.h
    types.cpp types.h
    utils.cpp utils.h
    watchers.h watchers.cpp
    x11-types.cpp x11-types.h
    x11-utils.cpp x11-utils.h
    xconnection.cpp xconnection.h
    xkeygrabber.cpp xkeygrabber.h
    xmainloop.cpp xmainloop.h
    )

# we require C++11
set_target_properties(herbstluftwm PROPERTIES
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON)

## options
include(CMakeDependentOption)
cmake_dependent_option(WITH_XINERAMA "Use multi-monitor support via xinerama" ON
    "XINERAMA_FOUND" OFF)

if (WITH_XINERAMA)
    set_property(SOURCE monitordetection.cpp APPEND PROPERTY COMPILE_DEFINITIONS XINERAMA)
    target_link_libraries(herbstluftwm PRIVATE ${XINERAMA_LIBRARIES})
endif()

## dependencies X11 (link to Xext for XShape())
target_include_directories(herbstluftwm SYSTEM PUBLIC
    ${FREETYPE_INCLUDE_DIRS}
    ${X11_INCLUDE_DIRS}
    ${XFT_INCLUDE_DIRS}
    ${XEXT_INCLUDE_DIRS}
    ${XINERAMA_INCLUDE_DIRS}
    ${XRANDR_INCLUDE_DIRS}
    )
target_link_libraries(herbstluftwm PUBLIC
    ${FREETYPE_LIBRARIES}
    ${X11_LIBRARIES}
    ${XEXT_LIBRARIES}
    ${XFT_LIBRARIES}
    ${XINERAMA_LIBRARIES}
    ${XRANDR_LIBRARIES}
    )

## export variables to the code
# version string
export_version(main.cpp)
# systemwide autostart location
set_property(SOURCE main.cpp APPEND PROPERTY COMPILE_DEFINITIONS
    HERBSTLUFT_GLOBAL_AUTOSTART=\"${CONFIGDIR}/autostart\")

# vim: et:ts=4:sw=4

=== debian/changelog ===
herbstluftwm (0.9.2-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Christoph Egger <christoph@debian.org>  Wed, 03 Mar 2021 15:24:58 +0100

herbstluftwm (0.9.2-1) unstable; urgency=medium

  * New upstream release
  * New dependencies: freetype, xft, pkg-config
  * Needs its python module now for tests
  * Fix zsh completion path (Closes: #843573)

 -- Christoph Egger <christoph@debian.org>  Wed, 17 Feb 2021 19:59:18 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# PYTEST_VERSION = $(shell python3 -c 'import sys ; print("py" + "".join([str(i) for i in sys.version_info[:2]]))')

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- -DZSHCOMPLETIONDIR=/usr/share/zsh/vendor-completions -DCOPY_DOCUMENTATION=NO

override_dh_auto_install:
	dh_auto_install --buildsystem=cmake
	rm -f $(CURDIR)/debian/herbstluftwm/usr/share/doc/herbstluftwm/INSTALL

override_dh_auto_test:
	(cd obj-* ; PYTHONPATH=../python python3 -m pytest -x ../tests)


override_dh_installwm:
	dh_installwm --priority=20 herbstluftwm

## herbstluftwm 0.9.3

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -84,7 +84,7 @@
                     -a \"builddir=${CMAKE_CURRENT_BINARY_DIR}\"
                     --destination-dir="${CMAKE_CURRENT_BINARY_DIR}"
                     ${src}
-            DEPENDS ${ARGN}
+            DEPENDS ${src} ${ARGN}
             )
     endif()
     install(FILES ${dst} DESTINATION "${MANDIR}/man${man_nr}")
@@ -120,7 +120,7 @@
             DEPENDS ${src} ${ARGN}
             )
     endif()
-    install(FILES ${dst} DESTINATION ${DOCDIR})
+    install(FILES ${dst} DESTINATION "${DOCDIR}/html")
 endfunction()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,7 @@
     completion.h completion.cpp
     decoration.cpp decoration.h
     desktopwindow.h desktopwindow.cpp
+    either.h
     entity.cpp entity.h
     ewmh.cpp ewmh.h
     finite.h
@@ -30,6 +31,7 @@
     frameparser.h frameparser.cpp
     frametree.h frametree.cpp
     globals.h
+    globalcommands.cpp globalcommands.h
     hlwmcommon.cpp hlwmcommon.h
     hook.cpp hook.h
     indexingobject.h
@@ -56,6 +58,7 @@
     root.cpp root.h
     rulemanager.cpp rulemanager.h
     rules.cpp rules.h
+    runtimeconverter.h
     settings.cpp settings.h
     signal.h
     stack.cpp stack.h
@@ -64,7 +67,8 @@
     theme.cpp theme.h
     tilingresult.cpp tilingresult.h
     tmp.cpp tmp.h
-    types.cpp types.h
+    converter.cpp converter.h
+    typesdoc.cpp typesdoc.h
     utils.cpp utils.h
     watchers.h watchers.cpp
     x11-types.cpp x11-types.h
@@ -97,6 +101,7 @@
     ${XEXT_INCLUDE_DIRS}
     ${XINERAMA_INCLUDE_DIRS}
     ${XRANDR_INCLUDE_DIRS}
+    ${XRENDER_INCLUDE_DIRS}
     )
 target_link_libraries(herbstluftwm PUBLIC
     ${FREETYPE_LIBRARIES}
@@ -105,6 +110,7 @@
     ${XFT_LIBRARIES}
     ${XINERAMA_LIBRARIES}
     ${XRANDR_LIBRARIES}
+    ${XRENDER_LIBRARIES}
     )
 
 ## export variables to the code

=== debian/changelog ===
herbstluftwm (0.9.3-2) unstable; urgency=medium

  * upload to unstable

 -- Christoph Egger <christoph@debian.org>  Tue, 12 Oct 2021 21:17:29 +0200

herbstluftwm (0.9.3-1) experimental; urgency=medium

  * New upstream release

 -- Christoph Egger <christoph@debian.org>  Sun, 16 May 2021 17:34:27 +0200

## herbstluftwm 0.9.4

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -74,10 +74,16 @@
             COMMENT "Using pre-built ${dst_prebuilt}"
             )
     else()
+        # create a config file such that we can tell a2x to call
+        # our script patching the man page xml instead of running xmllint
+        set(custom_asciidoc_cfg "${CMAKE_CURRENT_BINARY_DIR}/a2x-patched-dont-install.conf")
+        file(WRITE ${custom_asciidoc_cfg}
+        "XMLLINT = '${CMAKE_CURRENT_SOURCE_DIR}/patch-manpage-xml.py'")
         add_custom_command(
             OUTPUT ${dst}
             COMMAND ${ASCIIDOC_A2X}
-                    --no-xmllint
+                    --verbose
+                    --conf-file=${custom_asciidoc_cfg}
                     -f manpage
                     -a \"herbstluftwmversion=herbstluftwm ${VERSION}\"
                     -a \"date=${BUILD_DATE}\"

=== debian/changelog ===
herbstluftwm (0.9.4-5.0antix1) unstable; urgency=medium

  * antiX build 

 -- anticapitalista <antix@operamail.com>  Sun, 29 May 2022 18:38:43 +0300

herbstluftwm (0.9.4-5) unstable; urgency=medium

  * Double timeouts again

 -- Christoph Egger <christoph@debian.org>  Fri, 27 May 2022 11:05:47 +0200

herbstluftwm (0.9.4-4) unstable; urgency=medium

  * Double shutdown timeout in testsuite hope it helps slow buildds

 -- Christoph Egger <christoph@debian.org>  Thu, 26 May 2022 20:07:53 +0200

herbstluftwm (0.9.4-3) unstable; urgency=medium

  * Import upstream patches for CI reliability
    + 7c4540919b3c55a301bc0f325e479574294802c9
      IPC: drop property events from queue early
    + b68641644f55b4f149430ebd146aa748c6508511
      CI: wait for client acquiring input focus

 -- Christoph Egger <christoph@debian.org>  Thu, 26 May 2022 13:49:15 +0200

herbstluftwm (0.9.4-2) unstable; urgency=medium

  * Double Timeout for slower architectures

 -- Christoph Egger <christoph@debian.org>  Thu, 17 Mar 2022 17:09:00 +0100

herbstluftwm (0.9.4-1) unstable; urgency=medium

  [ Christoph Egger ]
  * New upstream release
     * New dependency on libxfixes
  [ Debian Janitor ]
  * Bump debhelper from old 12 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Update standards version to 4.1.5, no changes needed.

 -- Christoph Egger <christoph@debian.org>  Wed, 16 Mar 2022 17:29:12 +0100

=== debian/control ===
Source: herbstluftwm
Section: x11
Priority: optional
Maintainer: Christoph Egger <christoph@debian.org>
Build-Depends:
 asciidoc,
 cmake,
 debhelper-compat (= 12),
 docbook-xml,
 docbook-xsl,
 libfreetype6-dev,
 libx11-dev,
 libxfixes-dev,
 libxft-dev,
 libxinerama-dev,
 libxml2-utils,
 libxrandr-dev,
 pkg-config,
 python3,
 python3-ewmh,
 python3-pytest,
 python3-pytest-xdist,
 python3-pytest-xvfb,
 python3-xlib,
 x11-utils,
 x11-xserver-utils,
 xdotool,
 xserver-xephyr,
 xsltproc,
 xterm
Standards-Version: 4.1.5
Homepage: https://herbstluftwm.org
Vcs-Git: https://salsa.debian.org/debian/herbstluftwm.git
Vcs-Browser: https://salsa.debian.org/debian/herbstluftwm

Package: herbstluftwm
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: dzen2, xterm, xfonts-base
Suggests: suckless-tools
Provides: x-window-manager
Description: manual tiling window manager for X11
 In herbstluftwm the layout is based on splitting frames into
 subframes which can be split again or can be filled with windows,
 Tags (or workspaces or virtual desktops or ...) can be added/removed
 at runtime. Each tag contains an own layout and exactly one tag is
 viewed on each monitor. The tags are monitor independent.
 .
 It is configured at runtime via ipc calls from herbstclient. So the
 configuration file is just a script which is run on startup.

=== debian/rules ===
--- 
+++ 
@@ -13,9 +13,6 @@
 	dh_auto_install --buildsystem=cmake
 	rm -f $(CURDIR)/debian/herbstluftwm/usr/share/doc/herbstluftwm/INSTALL
 
-override_dh_auto_test:
-	(cd obj-* ; PYTHONPATH=../python python3 -m pytest -x ../tests)
-
 
 override_dh_installwm:
 	dh_installwm --priority=20 herbstluftwm

## herbstluftwm 0.9.5

=== Makefile ===
--- 
+++ 
@@ -16,3 +16,29 @@
 
 clean:
 	rm -r $(BUILDDIR)/
+
+.PHONY: smoke-test
+smoke-test: all
+	$(MAKE) tox EXTRA_TOX_ARGS="-m 'not exclude_from_coverage'"
+
+.PHONY: long-test
+long-test: all
+	$(MAKE) tox EXTRA_TOX_ARGS="-m 'exclude_from_coverage'"
+
+.PHONY: test
+test: smoke-test long-test
+
+.PHONY: tox
+tox: all
+	cd $(BUILDDIR); tox -c ..  -- -v --maxfail=1 $(EXTRA_TOX_ARGS)
+
+.PHONY: flake8
+flake8:
+	flake8
+
+.PHONY: check-using-std
+check-using-std:
+	./ci/check-using-std.sh
+
+.PHONY: check
+check: check-using-std flake8 test

=== share/CMakeLists.txt ===
add_custom_target("copy_autostart" ALL)
add_custom_command(
    TARGET copy_autostart POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy
    ${CMAKE_CURRENT_SOURCE_DIR}/autostart
    ${CMAKE_CURRENT_BINARY_DIR}/autostart)

install(FILES herbstclient-completion.bash
    RENAME herbstclient
    DESTINATION ${BASHCOMPLETIONDIR})
install(FILES _herbstclient           DESTINATION ${ZSHCOMPLETIONDIR})
install(FILES herbstclient.fish       DESTINATION ${FISHCOMPLETIONDIR})
install(FILES herbstluftwm.desktop    DESTINATION ${XSESSIONSDIR})

install(PROGRAMS
    autostart
    panel.sh
    restartpanels.sh
    dmenu_run_hlwm
    DESTINATION ${CONFIGDIR}
)

# vim: et:ts=4:sw=4

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,7 @@
     arglist.cpp arglist.h
     argparse.cpp argparse.h
     attribute.cpp attribute.h attribute_.h
+    autostart.cpp autostart.h
     byname.cpp byname.h
     child.h
     client.cpp client.h
@@ -102,6 +103,7 @@
     ${XINERAMA_INCLUDE_DIRS}
     ${XRANDR_INCLUDE_DIRS}
     ${XRENDER_INCLUDE_DIRS}
+    ${XFIXES_INCLUDE_DIRS}
     )
 target_link_libraries(herbstluftwm PUBLIC
     ${FREETYPE_LIBRARIES}
@@ -111,6 +113,7 @@
     ${XINERAMA_LIBRARIES}
     ${XRANDR_LIBRARIES}
     ${XRENDER_LIBRARIES}
+    ${XFIXES_LIBRARIES}
     )
 
 ## export variables to the code

=== utilities/Makefile ===
INCS = -Isrc/ -I/usr/include -I${X11INC}
LIBS = -lc -L${X11LIB} -lXext -lX11

CFLAGS += -g -Wall -Wextra -std=c99 ${INCS}
LDFLAGS += ${LIBS}

BIN = $(patsubst %.c,%,$(wildcard *.c))

.PHONY: all clean .gitignore

all: $(BIN)

clean:
	rm -f $(BIN)

.gitignore:
	printf "%s\n" $(BIN) | tee .gitignore

=== www/Makefile ===

.PHONY: all clean install

TARGET = herbstluftwm.org:html/

ASCIIDOC = asciidoc
ASCIIDOCFLAGS = -s -a "builddir=${PWD}"
TXT = $(shell git ls-files '*.txt')
INSTALLFILES = $(TXT:.txt=.html) \
	herbstluftwm.html \
	herbstclient.html \
	herbstluftwm.svg \
	favicon.ico \
	main.css \
	.htaccess \
	hlwm-doc.json \
	$(LINKS)

LINKS = NEWS MIGRATION

all: $(INSTALLFILES)

%-content.html: %.txt
	$(call colorecho,DOC,$@)
	$(ASCIIDOC) $(ASCIIDOCFLAGS) -o $@ $<

%.html: %-content.html compose.py
	./compose.py $< > $@

hlwm-objects-gen.txt: hlwm-doc.json ../doc/format-doc.py
	../doc/format-doc.py $< > $@

herbstluftwm.svg: ../share/herbstluftwm.svg
	cp $^ $@

news.html: ../NEWS

migration.html: ../MIGRATION

herbstluftwm.html: ../doc/herbstluftwm.txt hlwm-objects-gen.txt

object-doc.html: hlwm-objects-gen.txt

herbstclient.html: ../doc/herbstclient.txt

tutorial.html: ../doc/herbstluftwm-tutorial.txt

faq-toc.html: faq-content.html ./gentoc.sh
	./gentoc.sh $< > $@

faq.html: faq-toc.html

favicon.ico: ../share/herbstluftwm.svg
	convert -density 256x256 -background transparent $< \
        -define icon:auto-resize -colors 256 $@

hlwm-doc.json: ../doc/gendoc.py $(wildcard ../src/*.*)
	../doc/gendoc.py --sourcedir ../src --json > $@

# some symbolic links to make links in these asciidoc files work in www, too
$(LINKS):
	ln -sf $(shell echo $@ | tr A-Z a-z).html $@

clean:
	rm -f *.html *-content.html $(LINKS) hlwm-objects-gen.txt

install: all
	rsync -v -l $(INSTALLFILES) $(TARGET)

=== debian/changelog ===
herbstluftwm (0.9.5-3) unstable; urgency=medium

  * Disable tests, too unreliable

 -- Christoph Egger <christoph@debian.org>  Mon, 17 Oct 2022 13:31:46 +0200

herbstluftwm (0.9.5-2) unstable; urgency=medium

  * Update error message expected in test -- patch from upstream
    (Closes: #1012943)

 -- Christoph Egger <christoph@debian.org>  Wed, 10 Aug 2022 09:04:23 +0200

herbstluftwm (0.9.5-1) unstable; urgency=medium

  * New upstream release
  * Remove upstream patches added to 0.9.4-3

 -- Christoph Egger <christoph@debian.org>  Mon, 08 Aug 2022 22:09:29 +0300

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends:
  asciidoc,
  cmake,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  docbook-xml,
  docbook-xsl,
  libfreetype6-dev,

=== debian/rules ===
--- 
+++ 
@@ -13,6 +13,9 @@
 	dh_auto_install --buildsystem=cmake
 	rm -f $(CURDIR)/debian/herbstluftwm/usr/share/doc/herbstluftwm/INSTALL
 
+override_dh_auto_test:
+	-(cd obj-* ; PYTHONPATH=../python python3 -m pytest -x ../tests)
+
 
 override_dh_installwm:
 	dh_installwm --priority=20 herbstluftwm

=== debian/watch ===
version=3

opts=pgpsigurlmangle=s/$/.sig/ \
https://herbstluftwm.org/tarballs/herbstluftwm-([\d.]+).tar.gz
